<?php
/*
Plugin Name: Diga Cultura PVR
Version: 3.1.1
Plugin URI: http://digacultura.net/ferramentas/pvr
Description: Adiciona um botão de Publicação e Votação Remota do agregador DigaCultura a páginas, posts individuais e/ou homepage do seu WordPress.
Author: Sergio Dinis Lopes
Author URI: http://sergiolopes.name/
*/

$message = "";

if (!function_exists('dcpvr_request_handler')) {
    function dcpvr_request_handler() {
        global $message;

        if ($_POST['dcpvr_action'] == "update options") {
            $dcpvr_align_v = $_POST['dcpvr_align_sl'];

			// Post PVR Align
    		if(get_option("dcpvr_box_align")) {
    			update_option("dcpvr_box_align", $dcpvr_align_v);
    		} else {
    			add_option("dcpvr_box_align", $dcpvr_align_v);
    		}
			
			// Post PVR Where?
            $dcpvr_where_v = $_POST['dcpvr_where_sl'];
			if(!empty($dcpvr_where_v)){$dcpvr_where_v = implode(',',$dcpvr_where_v);}
			else {$dcpvr_where_v = 'home,posts';}
    		
			if(get_option("dcpvr_box_where")) {
    			update_option("dcpvr_box_where", $dcpvr_where_v);
    		} else {
    			add_option("dcpvr_box_where", $dcpvr_where_v);
    		}
			
			// Post PVR Skin
            $dcpvr_bgcolor_v = $_POST['dcpvr_bgcolor_sl'];
    		
			if(get_option("dcpvr_box_bgcolor")) {
    			update_option("dcpvr_box_bgcolor", $dcpvr_bgcolor_v);
    		} else {
    			add_option("dcpvr_box_bgcolor", $dcpvr_bgcolor_v);
    		}
			
			// Post PVR Window
            $dcpvr_window_v = $_POST['dcpvr_window_sl'];
    		
			if(get_option("dcpvr_box_window")) {
    			update_option("dcpvr_box_window", $dcpvr_window_v);
    		} else {
    			add_option("dcpvr_box_window", $dcpvr_window_v);
    		}
			
			// Post PVR Window
            $dcpvr_window_v = $_POST['dcpvr_window_sl'];
    		
			if(get_option("dcpvr_box_window")) {
    			update_option("dcpvr_box_window", $dcpvr_window_v);
    		} else {
    			add_option("dcpvr_box_window", $dcpvr_window_v);
    		}


            $message = '<br clear="all" /> <div id="message" class="updated fade"><p><strong>Opções Guardadas</strong></p></div>';
        }
    }
}

if(!function_exists('dcpvr_add_menu')) {
    function dcpvr_add_menu () {
        add_options_page("Diga Cultura PVR", "Diga Cultura PVR", 8, basename(__FILE__), "dcpvr_displayOptions");
		
    }
}

if (!function_exists('dcpvr_displayOptions')) {
    function dcpvr_displayOptions() {
	
        global $message;
        echo $message;
		
		print('<div class="wrap">');
		print('<h2>Diga Cultura - Botão de Publicação e Votação Remota</h2>');
        print ('<form name="dcpvr_form" action="'. get_bloginfo("wpurl") . '/wp-admin/options-general.php?page=digacultura.php' .'" method="post">');
?>
        <p>O botão permite que os seus leitores enviem os seus conteúdos para o <a target="_blank" href="http://digacultura.net">Diga Cultura</a>, tendo assim uma maior audiência.</p>
        <table width="50%" border="0" class="form-table">
          <tr style="padding:10px;border-bottom:1px solid #d9d9d9;">
            <td width="300" align="left"><strong>Seleccione qual a posição que deseja para o botão:</strong></td>
            <td align="left">
        		<select name="dcpvr_align_sl" id="dcpvr_align_sl">
                    <option value="Topo Esquerdo"<?php if (get_option("dcpvr_box_align") == "Topo Esquerdo") echo(' selected="selected"'); ?> >Topo Esquerdo</option>
                    <option value="Topo Direito"<?php if (get_option("dcpvr_box_align") == "Topo Direito") echo(' selected="selected"'); ?> >Topo Direito</option>
                    <option value="Fundo Esquerdo"<?php if (get_option("dcpvr_box_align") == "Fundo Esquerdo") echo(' selected="selected"'); ?> >Fundo Esquerdo</option>
                    <option value="Fundo Direito"<?php if (get_option("dcpvr_box_align") == "Fundo Direito") echo(' selected="selected"'); ?> >Fundo Direito</option>
                    <option value="Nenhuma"<?php if (get_option("dcpvr_box_align") == "Nenhuma" || get_option("dcpvr_box_align") == "") echo(' selected="selected"'); ?> >Nenhuma</option>
                </select>
            </td>
          </tr>
          <tr style="padding:10px;border-bottom:1px solid #d9d9d9;">
            <td width="160"><strong>Cor de Fundo (formato CSS)</strong></td>
            <td><input type="text" name="dcpvr_bgcolor_sl" id="dcpvr_bgcolor_sl" value="<?php if (!get_option("dcpvr_box_bgcolor")) { echo "none";} else {echo get_option("dcpvr_box_bgcolor");} ?>" /></td>
          </tr>
          <tr style="padding:10px;border-bottom:1px solid #d9d9d9;">
            <td><h3><strong>Skin</strong></h3>
                <p>Aspecto gráfico ("Skins") dos vários botões:</p>
        
                <h3>standard</h3>
                <input type="radio" name="dcpvr_skin_sl" id="standard_button" value="standard"<?php if (get_option('dcpvr_box_skin') == '' || get_option('dcpvr_box_skin') == 'normal' || get_option('dcpvr_box_skin') == 'standard') echo(' checked="checked"'); ?>/>
                <label for="standard_button" style="background:url(http://digacultura.net/design/images/standard_button.png) no-repeat center bottom;padding:21px 25px;">&nbsp;</label>
                <br/><br/>
                <h3>compact</h3>
                <input type="radio" name="dcpvr_skin_sl" id="compact_button" value="compact"<?php if (get_option('dcpvr_box_skin') == 'compacto' || get_option('dcpvr_box_skin') == 'pequeno' || get_option('dcpvr_box_skin') == 'compact') echo(' checked="checked"'); ?> />
                <label for="compact_button" style="background:url(http://digacultura.net/design/images/compact_button.png) no-repeat center top;padding:3px 36px;">&nbsp;</label>
	    	</td>
          </tr>
          <tr style="padding:10px;border-bottom:1px solid #d9d9d9;">
            <td><strong>Abrir...</strong></td>
            <td>
                <select name="dcpvr_window_sl" id="dcpvr_window_sl">
                    <option value="same"<?php if (get_option("dcpvr_box_window") == "same") echo(' selected="selected"'); ?> >Mesma Janela</option>
                    <option value="new"<?php if (get_option("dcpvr_box_window") == "new") echo(' selected="selected"'); ?> >Nova Janela</option>
                </select>
            </td>
          </tr>
          <tr style="padding:10px;border-bottom:1px solid #d9d9d9;">
            <td><strong>Aparecer em...</strong></td>
            <td>
            	<?php $dcpvr_box_where = get_option("dcpvr_box_where"); if(empty($dcpvr_box_where))$dcpvr_box_where = 'home,posts'; $dcpvr_box_where = explode(',',$dcpvr_box_where); ?>
                
                <input type="checkbox" name="dcpvr_where_sl[]" id="home" value="home"<?php if (in_array('home',$dcpvr_box_where)) echo(' checked="checked"'); ?> />
                <label for="home">Home</label>
                
                <input type="checkbox" name="dcpvr_where_sl[]" id="posts" value="posts"<?php if (in_array('posts',$dcpvr_box_where)) echo(' checked="checked"'); ?> />
                <label for="posts">Post Indívidual</label>
            
                <input type="checkbox" name="dcpvr_where_sl[]" id="pages" value="pages"<?php if (in_array('pages',$dcpvr_box_where)) echo(' checked="checked"'); ?> />
                <label for="pages">Páginas</label>
                
            </td>
          </tr>
        </table>

       <p>Para mais informação acerca do botão PVR clique <a target="_blank" href="http://digacultura.net/ferramentas/pvr">aqui</a>.</p>
<?php
		print ('<p class="submit"><input type="submit" value="Guardar Opções" /></p>');
		print ('<input type="hidden" name="dcpvr_action" value="update options" />');
		print('</form></div>');

    }
}


if (!function_exists('dcpvr_dcpvragehtml')) {
	function dcpvr_dcpvragehtml($float) {
		global $wp_query;
		$post = $wp_query->post;
		$permalink = get_permalink($post->ID);
        $title = urlencode($post->post_title);
		$pvrskin = get_option("dcpvr_box_skin");
		$pvrbgcolor = get_option("dcpvr_box_bgcolor");
		$pvrwindow = get_option("dcpvr_box_window");
		$dcpvragehtml = <<<CODE

    <span style="padding:5px; margin:0; float:$float;">
		<script type="text/javascript">
			pvr_url = "$permalink";
			pvr_skin = "$pvrskin";
			pvr_title = "$title";
			pvr_window = "$pvrwindow";
			pvr_bgcolor = "$pvrbgcolor";
		</script>
		<script type="text/javascript" src="http://digacultura.net/pvr/pvrbutton.js"></script>
    </span>
CODE;
	return  $dcpvragehtml;
	}
}


if (!function_exists('dcpvr_addbutton')) {
	function dcpvr_addbutton($content) {
    
		$dcpvr_box_where = get_option("dcpvr_box_where");
        if(empty($dcpvr_box_where))$dcpvr_box_where = 'home,posts';
		$dcpvr_box_where = explode(',', $dcpvr_box_where);
        
        if(is_home() && !in_array('home',$dcpvr_box_where)) return $content;
        if(is_single() && !in_array('posts',$dcpvr_box_where)) return $content;
        if(is_page() && !in_array('pages',$dcpvr_box_where)) return $content;
        
		if ( !is_feed() && !is_archive() && !is_search() && !is_404() ) {
    		if(! preg_match('|<!--sphinnit-->|', $content)) {
    		    $dcpvr_align = get_option("dcpvr_box_align");
    		    if ($dcpvr_align) {
                    switch ($dcpvr_align) {
                        case "Topo Esquerdo":
        		              return dcpvr_dcpvragehtml("left").$content;
                              break;
                        case "Topo Direito":
        		              return dcpvr_dcpvragehtml("Right").$content;
                              break;
                        case "Fundo Esquerdo":
        		              return $content.dcpvr_dcpvragehtml("left");
                              break;
                        case "Fundo Direito":
        		              return $content.dcpvr_dcpvragehtml("right");
                              break;
                        case "Nenhum":
        		              return $content;
                              break;
                        default:
        		              return dcpvr_dcpvragehtml("left").$content;
                              break;
                    }
                } else {
        		      return dcpvr_dcpvragehtml("left").$content;
                }

    		} else {
                  return str_replace('<!--dcpvrage-->', dcpvr_dcpvragehtml(""), $content);
            }
        } else {
			return $content;
        }
	}
}

add_filter('the_content', 'dcpvr_addbutton', 999);
add_action('admin_menu', 'dcpvr_add_menu');
add_action('init', 'dcpvr_request_handler');

?>